"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const supi_1 = require("supi");
const createStoreController_1 = require("../createStoreController");
exports.default = (input, opts) => __awaiter(this, void 0, void 0, function* () {
    const cwd = opts && opts.prefix || process.cwd();
    const store = yield createStoreController_1.default(opts);
    const linkOpts = Object.assign(opts, {
        store: store.path,
        storeController: store.ctrl,
    });
    // pnpm link
    if (!input || !input.length) {
        yield supi_1.linkToGlobal(cwd, linkOpts);
        return;
    }
    yield input.reduce((previous, inp) => {
        // pnpm link ../foo
        if (inp[0].indexOf('.') === 0) {
            const linkFrom = path.join(cwd, inp);
            return previous.then(() => supi_1.link(linkFrom, cwd, linkOpts));
        }
        // pnpm link foo
        return previous.then(() => supi_1.linkFromGlobal(inp, cwd, linkOpts));
    }, Promise.resolve());
});
//# sourceMappingURL=link.js.map